<h1 align="center">PyRival</h1>
<div align="center">
  <strong>A Python Library for Competitive Programming</strong>  
</div>

<h3 align="center">Developers</h3>
<div align="center">
  <strong>
    <a href="https://github.com/Mukundan314">Mukundan314</a> &emsp;
    <a href="https://codeforces.com/profile/pajenegod">pajenegod</a> &emsp;
    <a href="https://github.com/eduard-netsajev">drd93</a> &emsp;
    <a href="https://github.com/algmyr">algmyr</a> &emsp;
    <a href="https://github.com/meooow25">meooow</a> &emsp;
  </strong>
</div>

---

### Features
- Templates
- Programming Tools
- Algorithm Snippets

##

### Templates
- The [Master Template](template/template.py) works with all versions of Python and enables Python 3 code internally.
- Version Specific Templates: [PyPy 2](template/template_pypy2.py), [Python 3](template/template_py3.py)

##

### Tools
- Builtins
  - bootstrap for recursion
  - FastIO
  - heapq
  - sorted
  - py3k compatibility tools
  - random
  - str.split for whitespace
- Perfomance tools
  - Bit Hacks
  - 32-bit Modular Arithmetic
  - Memoize Decorators
  - C++ syle cout
- Testing tools
  - Interactive Runner
  - Stress Tester

##

### Snippets
- Algebra
  - (Multivariable) Chinese Remainder Theorem
  - Discrete Logarithm
  - Least Common Multiple
  - Integer Factorization
  - Fast Fourier Transform
  - Fast Subset Transform
  - Number Theoretic Transform
  - Deterministic Miller-Rabin Primality Test
  - Tonelli–Shanks Algorithm
  - Generalized Modular Inverse
  - Euler's Phi Function
  - Primitive Root
  - Sieve of Eratosthenes
- Data Structures
  - Bit Array
  - Binary Indexed (Fenwick) Tree
  - Fractions
  - Continued Fractions
  - Disjoint-Set (Union Find) Data Structure
  - Generic Nodes
  - Linked List
  - Range Query Data Structure
  - (Lazy) Segment Tree
  - Persistent Segment Tree
  - Sorted List
  - Treap
  - Trie Tree
  - 2-satisfiability Template
- Geometry
  - Convex Hull
  - Line Functions
  - Polygon Functions
  - Vector Functions
- Graphs
  - Bellman-Ford Algorithm
  - Breadth First Search
  - Connected Components Search
  - Brent's Algorithm for Cycle Detection
  - Depth First Search
  - Dijkstra's Algorithm
  - Eulerian Path
  - Path Constructor
  - Floyd-Warshall Algorithm
  - Bipartite Graph Check
  - Kruskal's Algorithm with Disjoin Set Union
  - Prim's Algorithm
  - Tarjan's Algorithm
  - Topological Sorting
- Combinatorics
  - General Purpose Numbers
  - Lucas's Theorem
  - Partition Function
- Linear Algebra
  - Matrix Arithmetic, Exponentiation, Determinant, and Inverse
  - Gaussian Elimination
  - Multivariable Chinese Remainder Theorem
- Numerical
  - Linear Recurrence Template
  - Hill Climbing Algorithm
  - Approximate Integration
  - Polynomial Interpolation
  - Integer Roots
  - Binary Search
- Strings
  - Knuth–Morris–Pratt Algorithm
  - Longest Common/Palindromic Subsequences
  - Longest Common Substring
  - Manacher's Algorithm
  - Lydon Factorization
- Misc
  - Alpha–Beta Pruning
  - Longest Increasing Subsequence
  - K-th Order Statistic

##

### License
[Apache-2.0](LICENSE) (c) 2019
